#ifndef BPPTCHAR_H
#define BPPTCHAR_H
#include <bppdef.h>
#include <string.h>

#ifdef __TURBOC__
   #ifndef NO_TCHAR_H
      #define NO_TCHAR_H
   #endif
	#include <stddef.h>
#if __TURBOC__<0x0450
#define __OLDCPP__
#endif
#endif

#if defined(GCC) && !defined(WIN32)
#ifndef NO_TCHAR_H
   #define NO_TCHAR_H
#endif
#endif


#ifndef NO_TCHAR_H
   #include <tchar.h>
   #ifndef _TEOF
      #define _TEOF EOF
   #endif
#else
/* if no tchar.h available neither unicode nor multibyte characters are supported */
#ifdef _UNICODE
   #undef _UNICODE
#endif
#ifdef _MBCS
   #undef _MBCS
#endif
/* replacements for tchar.h defines */
#define _TEOF           EOF
#define _T(x) x
#define _tprintf        printf
#define _ftprintf       fprintf
#define _stprintf       sprintf
#define _vtprintf       vprintf
#define _vftprintf      vfprintf
#define _vstprintf      vsprintf

#define _tscanf         scanf
#define _ftscanf        fscanf
#define _stscanf        sscanf


/* Unformatted i/o */

#define _fgettc         fgetc
#define _fgetts         fgets
#define _fputtc         fputc
#define _fputts         fputs
#define _gettc          getc
#define _gettchar       getchar
#define _gettche        getche
#define _getts          gets
#define _puttc          putc
#define _puttchar       putchar
#define _putts          puts
#define _ungettc        ungetc

/* String conversion functions */

#define _tcstod     strtod
#define _tcstol     strtol
#define _tcstoul    strtoul
#ifdef EMULATE_I64
#define _tcstoi64    _strtoInt64
#define _tcstoui64    _strtoUInt64
#else
	#ifdef GCC
	   #define _strtoi64 strtoll
	   #define _strtoui64  strtoull
	#endif
	#define _tcstoi64    _strtoi64
	#define _tcstoui64    _strtoui64
	#define stricmp    strcasecmp
#endif
#define _tstof      atof
#define _tstol      atol
#define _tstoi      atoi

#define _ttoi       atoi
#define _ttol       atol

/* String functions */

#define _tcscmp     strcmp
#define _tcsicmp     stricmp
#define _tcsncmp     strncmp
#define _tcsdup     strdup
#define _tcscat     strcat
#define _tcscat_s(BUF,SIZE,SRC) strcat(BUF,SRC)
#define _tcscpy_s(BUF,SIZE,SRC) strcpy(BUF,SRC)
#define _tcscpy     strcpy
#define _tcsncpy    strncpy
#define _tcslen     strlen
#define _tcsnlen    strnlen
#define _tcsxfrm    strxfrm
#define _tcserror   strerror
#define __tcserror  _strerror
#define _tcschr     strchr
#define _tcstok     strtok
#define _tcsstr     strstr
#define _tcsdup		strdup
#define _tcsupr		strupr
#define _tcslwr		strlwr
#define _tcscspn   strcspn
/* Execute functions */


#define _tsystem    system


/* Time functions */

#define _tasctime   asctime
#define _tctime     ctime
#define _tcsftime   strftime

/* Environment/Path functions */

#define _tgetenv        getenv
#define _tputenv        putenv
#define _tgetcwd		getcwd
#define _tchdir			chdir
#define _tfullpath		_fullpath
/* Stdio functions */

#define _tfopen     fopen
#define _tfreopen   freopen
#define _tperror    perror
#define _ttmpnam    tmpnam

#define _topen      open
#define _taccess    access

#define _tremove    remove
#define _trename    rename

/* ctype functions */
#define _istcntrl       iscntrl
#define _istxdigit      isxdigit
#define _istspace       isspace
#define _istupper       isupper
#define _istlower       islower
#define _istdigit       isdigit

#define _totlower       tolower
#define _totupper       toupper

#define _tmain          main
#define _tWinMain       WinMain
/* Setlocale functions */

#define _tsetlocale setlocale
#define _tsearchenv _searchenv

#endif /* end NO_TCHAR_H */

#ifdef _UNICODE
#define BppCharVal(V) ((BppUShort)(V))
#else
#define BppCharVal(V) ((BppSByte)(V))
#endif

#ifndef NO_TCHAR_H /* tchar.h exists but some definitions may be missing */

#ifndef _UNICODE

#ifndef _T
  #define _T(x) x
#endif

#ifndef _tcscat_s
    #define _tcscat_s(BUF,SIZE,SRC) strcat(BUF,SRC)
#endif
#ifndef _tcscpy_s
#define _tcscpy_s(BUF,SIZE,SRC) _tcscpy(BUF,SRC)
#endif

#ifndef _tsearchenv
	 #define _tsearchenv _searchenv
#else
  #ifdef __WATCOMC__  /* Watcom tchar.h has a bug in _tsearchenv definition */
	  #undef _tsearchenv
     #define _tsearchenv _searchenv
  #endif
#endif


#ifdef WIN32
#ifndef WINCE
#ifdef environ
#undef environ
#endif
#define environ _tenviron;
#endif
#endif

#ifndef _tgetcwd
#define _tgetcwd _getcwd
#endif

#ifndef _tchdir
#define _tchdir _chdir
#endif

#ifndef _tfullpath
#define _tfullpath _fullpath
#endif

#ifndef _tcsdup
#define _tcsdup _strdup
#endif

#ifndef _tsystem
#define _system system
#endif

#ifdef EMULATE_I64
#ifdef _tcstoi64
#undef _tcstoi64
#undef _tcstoui64
#endif
#define _tcstoi64    _strtoInt64
#define _tcstoui64    _strtoUInt64
#else /* !EMULATE_I64 */
#ifndef _tcstoi64
#define _tcstoi64    _strtoi64
#define _tcstoiu64   _strtoui64
#endif
#endif /* end !EMULATE_I64 */


#else /* end no unicode */

#ifndef _T
  #define _T(x) L##x
#endif

#ifdef WIN32
#ifndef WINCE
#ifdef environ
#undef environ
#endif
#define environ _tenviron;
#endif
#endif

#ifndef _tcscat_s
    #define _tcscat_s(BUF,SIZE,SRC) wcscat(BUF,SRC)
#endif
#ifndef _tsearchenv
    #define _tsearchenv _wsearchenv
#endif

#ifndef _tgetcwd
#define _tgetcwd _wgetcwd
#endif

#ifndef _tchdir
#define _tchdir _wchdir
#endif

#ifndef _tfullpath
#define _tfullpath _wfullpath
#endif

#ifndef _tcsdup
#define _tcsdup _wcsdup
#endif

#ifndef _tsystem
#define _tsystem _wsystem
#endif

#ifndef _tcstoi64
#define _tcstoi64    _wcstoi64
#define _tcstoiu64   _wcstoui64
#endif


#endif /* end unicode */

#endif /* end !NO_TCHAR_H */


#ifdef WINCE
#ifndef _tcscat_s
#define _tcscat_s(BUF,SIZE,SRC) _tcscat(BUF,SRC)
#endif
#ifndef _tcscpy_s
#define _tcscpy_s(BUF,SIZE,SRC) _tcscpy(BUF,SRC)
#endif
#ifdef _gettche
   #undef _gettche
#endif

#endif

#endif /* BPPTCHAR_H */

