#ifndef BPPUFUNC_H
#define BPPUFUNC_H

#include <bppdef.h>

BPPLIB_DLLEXP const BppChar* searchPath(const BppChar* fname);
BPPLIB_DLLEXP const BppChar* searchEnv(const BppChar* varname, const BppChar* fname);
BPPLIB_DLLEXP const BppChar* searchDirList(const BppChar* dirList, const BppChar* fname);
BPPLIB_DLLEXP void errorExit(int err);
BPPLIB_DLLEXP void* allocmem(size_t blksize);
BPPLIB_DLLEXP void* reallocmem(void* p, size_t blksize);
BPPLIB_DLLEXP void freemem(void* p);
BPPLIB_DLLEXP BppIntPtr movemem(BppIntPtr dst, BppIntPtr src, BppUInt n);
BPPLIB_DLLEXP const BppChar* getFileDir(const BppChar* filePath, bool stripSlash);
BPPLIB_DLLEXP BppChar* dupstr(const BppChar* src);
#ifdef WINCE
#ifdef _gettche
	#undef _gettche
#endif

BPPLIB_DLLEXP const BppChar* _tgetenv(const BppChar* varname);
BPPLIB_DLLEXP int _tputenv(const BppChar* envstr);

BPPLIB_DLLEXP int _gettche();
BPPLIB_DLLEXP time_t time(time_t* t);
BPPLIB_DLLEXP BppChar* _tctime(time_t* tt);

struct BPPLIB_DLLEXP tm
{
	int tm_sec, tm_min, tm_hour, tm_mday, tm_mon, tm_year, tm_wday, tm_yday, tm_isdst;
};

BPPLIB_DLLEXP tm* localtime( const time_t* t);

#endif // WINCE

#ifndef _vsctprintf
#include <stdarg.h>
	BPPLIB_DLLEXP int _vscprintf(const char* format, va_list args);
 #ifndef WIN32
	BPPLIB_DLLEXP int _vscwprintf(const wchar_t* format, va_list args);
 #endif
 #ifndef _UNICODE
	  #define _vsctprintf _vscprintf
 #else
	  #define _vsctprintf _vscwprintf
 #endif
 #define emulate_vsctprintf
#endif

#ifndef _vstprintf_s
  #ifndef _UNICODE
	  #define _vstprintf_s(BUF,CNT,FORMAT,ARGS)  vsprintf(BUF,FORMAT,ARGS)
  #else
	  #define _vstprintf_s(BUF,CNT,FORMAT,ARGS)  vswprintf(BUF,FORMAT,ARGS)
  #endif
#endif 
#if defined(UNIX)
   char* _fullpath(char* absPath,const char* relPath, size_t maxLength);
#endif
#endif // BPPUFUNC_H
