double optInterval(double vmin, double vmax, unsigned steps)
{
    static const double multipliers[] = {1,2,2.5,3,4,5,8,10};
    static const unsigned cntmul = sizeof(multipliers)/sizeof(double);
    double vdiff = vmax-vmin;
    double lgstep = log10(vdiff/(double)steps);
   unsigned i;
    double factor = pow(10.0,floor(lgstep));
    double diffmin = vdiff;
    double multiplier = 1.0;
    double tmp;
    for (i=0;i<cntmul;++i)
    {
        tmp = fabs(vdiff-(factor*multipliers[i]*steps));
        if (tmp > diffmin) break;

        diffmin = tmp;
        multiplier = multipliers[i];

    }
    return factor*multiplier;
}
